#include "global.h"
#include "regs.h"
#include "functions.h"
#include "flags.h"
#include "opcode.h"

#undef __PROC__
#define __PROC__ "OptValuePropogate"


extern BOOL OptValuePropogate(FILE *fp )
{
    int i;
    double percentage;
    int count = 0;
    BOOL change = 0;
    clock_t time = clock();
    BOOL verbose = HasOption(PRINT_OPT_VERBOSE,"Valueprop");

    if (verbose) {
	printf("MagicString valueprop\n");
    }
    for (i = 0; i < aValueCount; i++) {
	/* only call this function when most frequent
	   value is used more than 75% of the time */
	/* XXXX refine this later */
	if (aValues[i].totalcount > 0)
	    percentage = (double)(aValues[i].values[0].count)/(double)(aValues[i].totalcount);
	else percentage = 0;

	if (verbose) {
	    printf("percentage is %lf\n", percentage);
	    printf("count is %ld  value is %lx, total is %ld\n", aValues[i].values[0].count, aValues[i].values[0].addr, aValues[i].totalcount);
	}
	if ((percentage > 0.75 )  && (aValues[i].values[0].addr < 32768)) {
	    if (verbose)
		printf("cloning at instruction %ld with value %lx\n", 
		       aValues[i].iins & 0xffffffff, aValues[i].values[0].addr);
	    ValProfCloneBbls(aValues[i].iins & 0xffffffff, aValues[i].values[0].addr, percentage);
	    count++;
	}
    }
    
    time = (clock() - time) * 1000 / CLOCKS_PER_SEC;    
    change = (count>0);
    InfoStatus(fp, "\t[OptValuePropogate%c] Inlined Funs: %d {%d ms}\n",
	       CHANGE(change),count,time);

    if (verbose) {
	printf("MagicString valueprop\n");
    }
    return change;

}










