/*=======================================================
=======================================================*/

#include "global.h"
#include "opcode.h"
#include "flags.h"

extern const OPCODE_TAB_ENTRY InstructionTable[];


const OPCODE_TAB_ENTRY InstructionTable[] =
{
    /* 0x00 */

    /* implicit trapb in pal */
    {0x00,0x00,I_call_pal,"call_pal", IT_PAL, 0, RES_TR|RES_PC, PIPE_E1, 1, 1},
    {0x01,0x01,I_opc01,"opc01",       IT_ERR, 0, 0, 0, 0, 0},
    {0x02,0x02,I_opc02,"opc02",       IT_ERR, 0, 0, 0, 0, 0},
    {0x03,0x03,I_opc03,"opc03",       IT_ERR, 0, 0, 0, 0, 0},
    {0x04,0x04,I_opc04,"opc04",       IT_ERR, 0, 0, 0, 0, 0},
    {0x05,0x05,I_opc05,"opc05",       IT_ERR, 0, 0, 0, 0, 0},
    {0x06,0x06,I_opc06,"opc06",       IT_ERR, 0, 0, 0, 0, 0},
    {0x07,0x07,I_opc07,"opc07",       IT_ERR, 0, 0, 0, 0, 0},

    /* 0x08 */

    {0x08,0x08,I_lda,"lda",           IT_LDA, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x09,0x09,I_ldah,"ldah",         IT_LDA, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x0a,0x0a,I_ldbu,"ldbu",         IT_ILD, RES_PC|RES_LD|RES_MM, 0, PIPE_E0|PIPE_E1, 2, 2},
    {0x0b,0x0b,I_ldq_u,"ldq_u",       IT_ULD, RES_PC|RES_LD|RES_MM, 0, PIPE_E0|PIPE_E1, 2, 2},
    {0x0c,0x0c,I_ldwu,"ldwu",         IT_ILD, RES_PC|RES_LD|RES_MM, 0, PIPE_E0|PIPE_E1, 2, 2},

    {0x0d,0x0d,I_stw,"stw",           IT_IST, RES_PC|RES_ST, RES_MM, PIPE_E0, 0, 0},
    {0x0e,0x0e,I_stb,"stb",           IT_IST, RES_PC|RES_ST, RES_MM, PIPE_E0, 0, 0},
    {0x0f,0x0f,I_stq_u,"stq_u",       IT_UST, RES_PC|RES_ST, RES_MM, PIPE_E0, 0, 0},

    /* 0x10 */

    {0x10,0x10,I_opc10,"opc10",       IT_X10, 0, 0, 0, 0, 0},
    {0x11,0x11,I_opc11,"opc11",       IT_X11, 0, 0, 0, 0, 0},
    {0x12,0x12,I_opc12,"opc12",       IT_X12, 0, 0, 0, 0, 0},
    {0x13,0x13,I_opc13,"opc13",       IT_X13, 0, 0, 0, 0, 0},
    {0x14,0x14,I_opc14,"opc14",       IT_X14, 0, 0, 0, 0, 0},
    {0x15,0x15,I_opc15,"opc15",       IT_X15, 0, 0, 0, 0, 0},
    {0x16,0x16,I_opc16,"opc16",       IT_X16, 0, 0, 0, 0, 0},
    {0x17,0x17,I_opc17,"opc17",       IT_X17, 0, 0, 0, 0, 0},

    /* 0x18 */
    
    {0x18,0x18,I_opc18,"opc18",       IT_X18, 0, 0, 0, 0, 0},
    /* NEEDS WORK: HW_MFPR */
    {0x19,0x19,I_pal19,"pal19",       IT_ERR, 0, 0, 0, 0, 0},   
    {0x1a,0x1a,I_opc1a,"opc1a",       IT_X1A, 0, 0, 0, 0, 0},
    /* NEEDS WORK: HW_LD   */
    {0x1b,0x1b,I_pal1b,"pal1b",       IT_ERR, 0, 0, 0, 0, 0},   
    {0x1c,0x1c,I_opc1c,"opc1c",       IT_X1C, 0, 0, 0, 0, 0},
    /* NEEDS WORK: HW_MTPR */
    {0x1d,0x1d,I_pal1d,"pal1d",       IT_ERR, 0, 0, 0, 0, 0},
    /* NEEDS WORK: HW_REI  */
    {0x1e,0x1e,I_pal1e,"pal1e",       IT_ERR, 0, 0, 0, 0, 0},
    /* NEEDS WORK: HW_ST   */
    {0x1f,0x1f,I_pal1f,"pal1f",       IT_ERR, 0, 0, 0, 0, 0},   
    
    /* 0x20 */

    {0x20,0x20,I_ldf,"ldf",           IT_FLD, RES_PC|RES_LD|RES_MM, 0, PIPE_E0|PIPE_E1, 2, 12},
    {0x21,0x21,I_ldg,"ldg",           IT_FLD, RES_PC|RES_LD|RES_MM, 0, PIPE_E0|PIPE_E1, 2, 12},
    {0x22,0x22,I_lds,"lds",           IT_FLD, RES_PC|RES_LD|RES_MM, 0, PIPE_E0|PIPE_E1, 2, 12},
    {0x23,0x23,I_ldt,"ldt",           IT_FLD, RES_PC|RES_LD|RES_MM, 0, PIPE_E0|PIPE_E1, 2, 12},

    {0x24,0x24,I_stf,"stf",           IT_FST, RES_PC|RES_ST, RES_MM, PIPE_E0, 0, 0},
    {0x25,0x25,I_stg,"stg",           IT_FST, RES_PC|RES_ST, RES_MM, PIPE_E0, 0, 0},
    {0x26,0x26,I_sts,"sts",           IT_FST, RES_PC|RES_ST, RES_MM, PIPE_E0, 0, 0},
    {0x27,0x27,I_stt,"stt",           IT_FST, RES_PC|RES_ST, RES_MM, PIPE_E0, 0, 0},
    
    /* 0x28 */
    
    {0x28,0x28,I_ldl,"ldl",           IT_ILD, RES_PC|RES_LD|RES_MM, 0, PIPE_E0|PIPE_E1, 2, 12},
    {0x29,0x29,I_ldq,"ldq",           IT_ILD, RES_PC|RES_LD|RES_MM, 0, PIPE_E0|PIPE_E1, 2, 12},
    {0x2a,0x2a,I_ldl_l,"ldl_l",       IT_LLD, RES_PC|RES_LD|RES_MM, 0, PIPE_E0, 2, 12},
    {0x2b,0x2b,I_ldq_l,"ldq_l",       IT_LLD, RES_PC|RES_LD|RES_MM, 0, PIPE_E0, 2, 12},

    {0x2c,0x2c,I_stl,"stl",           IT_IST, RES_PC|RES_ST, RES_MM, PIPE_E0, 0, 0},
    {0x2d,0x2d,I_stq,"stq",           IT_IST, RES_PC|RES_ST, RES_MM, PIPE_E0, 0, 0},
    {0x2e,0x2e,I_stl_c,"stl_c",       IT_CST, RES_PC|RES_ST, RES_MM, PIPE_E0, 2, 12},
    {0x2f,0x2f,I_stq_c,"stq_c",       IT_CST, RES_PC|RES_ST, RES_MM, PIPE_E0, 2, 12},

    /* 0x30 */

    {0x30,0x30,I_br,"br",             IT_BRA, 0, RES_PC, PIPE_E1, 0, 0},
    {0x31,0x31,I_fbeq,"fbeq",         IT_FBR, 0, RES_PC, PIPE_FA, 0, 0},
    {0x32,0x32,I_fblt,"fblt",         IT_FBR, 0, RES_PC, PIPE_FA, 0, 0},
    {0x33,0x33,I_fble,"fble",         IT_FBR, 0, RES_PC, PIPE_FA, 0, 0},
    {0x34,0x34,I_bsr,"bsr",           IT_BRA, 0, RES_PC, PIPE_E1, 0, 0},
    {0x35,0x35,I_fbne,"fbne",         IT_FBR, 0, RES_PC, PIPE_FA, 0, 0},
    {0x36,0x36,I_fbge,"fbge",         IT_FBR, 0, RES_PC, PIPE_FA, 0, 0},
    {0x37,0x37,I_fbgt,"fbgt",         IT_FBR, 0, RES_PC, PIPE_FA, 0, 0},
    
    /* 0x38 */

    {0x38,0x38,I_blbc,"blbc",         IT_IBR, 0, RES_PC, PIPE_E1, 0, 0},
    {0x39,0x39,I_beq,"beq",           IT_IBR, 0, RES_PC, PIPE_E1, 0, 0},
    {0x3a,0x3a,I_blt,"blt",           IT_IBR, 0, RES_PC, PIPE_E1, 0, 0},
    {0x3b,0x3b,I_ble,"ble",           IT_IBR, 0, RES_PC, PIPE_E1, 0, 0},
    {0x3c,0x3c,I_blbs,"blbs",         IT_IBR, 0, RES_PC, PIPE_E1, 0, 0},
    {0x3d,0x3d,I_bne,"bne",           IT_IBR, 0, RES_PC, PIPE_E1, 0, 0},
    {0x3e,0x3e,I_bge,"bge",           IT_IBR, 0, RES_PC, PIPE_E1, 0, 0},
    {0x3f,0x3f,I_bgt,"bgt",           IT_IBR, 0, RES_PC, PIPE_E1, 0, 0},

    /* Table10 */
    
    {0x10,0x00,I_beg10,"beg10",       IT_ERR, 0, 0, 0, 0, 0},
    {0x10,0x00,I_addl,"addl",         IT_IOP, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x10,0x02,I_s4addl,"s4addl",     IT_IOP, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x10,0x09,I_subl,"subl",         IT_IOP, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x10,0x0b,I_s4subl,"s4subl",     IT_IOP, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x10,0x0f,I_cmpbge,"cmpbge",     IT_ICP, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x10,0x12,I_s8addl,"s8addl",     IT_IOP, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x10,0x1b,I_s8subl,"s8subl",     IT_IOP, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x10,0x1d,I_cmpult,"cmpult",     IT_ICP, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x10,0x20,I_addq,"addq",         IT_IOP, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x10,0x22,I_s4addq,"s4addq",     IT_IOP, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x10,0x29,I_subq,"subq",         IT_IOP, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x10,0x2b,I_s4subq,"s4subq",     IT_IOP, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x10,0x2d,I_cmpeq,"cmpeq",       IT_ICP, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x10,0x32,I_s8addq,"s8addq",     IT_IOP, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x10,0x3b,I_s8subq,"s8subq",     IT_IOP, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x10,0x3d,I_cmpule,"cmpule",     IT_ICP, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x10,0x40,I_addl_v,"addl/v",     IT_IOP, RES_PC|RES_TR, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x10,0x49,I_subl_v,"subl/v",     IT_IOP, RES_PC|RES_TR, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x10,0x4d,I_cmplt,"cmplt",       IT_ICP, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x10,0x60,I_addq_v,"addq/v",     IT_IOP, RES_PC|RES_TR, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x10,0x69,I_subq_v,"subq/v",     IT_IOP, RES_PC|RES_TR, 0, PIPE_E0|PIPE_E1, 1, 1},    
    {0x10,0x6d,I_cmple,"cmple",       IT_ICP, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x10,0xff,I_end10,"end10",       IT_ERR, 0, 0, 0, 0, 0},
    
    /* Table11 */

    {0x10,0x00,I_beg11,"beg11",        IT_ERR, 0, 0, 0, 0, 0},
    {0x11,0x00,I_and,"and",            IT_LOG, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x11,0x08,I_bic,"bic",            IT_LOG, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x11,0x14,I_cmovlbs,"cmovlbs",    IT_ICM, RES_PC, 0, PIPE_E0|PIPE_E1, 2, 2},
    {0x11,0x16,I_cmovlbc,"cmovlbc",    IT_ICM, RES_PC, 0, PIPE_E0|PIPE_E1, 2, 2},
    {0x11,0x20,I_bis,"bis",            IT_LOG, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x11,0x24,I_cmoveq,"cmoveq",      IT_ICM, RES_PC, 0, PIPE_E0|PIPE_E1, 2, 2},
    {0x11,0x26,I_cmovne,"cmovne",      IT_ICM, RES_PC, 0, PIPE_E0|PIPE_E1, 2, 2},
    {0x11,0x28,I_ornot,"ornot",        IT_LOG, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x11,0x40,I_xor,"xor",            IT_LOG, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},
    {0x11,0x44,I_cmovlt,"cmovlt",      IT_ICM, RES_PC, 0, PIPE_E0|PIPE_E1, 2, 2},
    {0x11,0x46,I_cmovge,"cmovge",      IT_ICM, RES_PC, 0, PIPE_E0|PIPE_E1, 2, 2},
    {0x11,0x48,I_eqv,"eqv",            IT_LOG, RES_PC, 0, PIPE_E0|PIPE_E1, 1, 1},

    {0x11,0x61,I_amask,"amask",        IT_MSC, RES_PC, 0, PIPE_E0|PIPE_E1, 2, 2},  /* guessed */
    
    {0x11,0x64,I_cmovle,"cmovle",      IT_ICM, RES_PC, 0, PIPE_E0|PIPE_E1, 2, 2},
    {0x11,0x66,I_cmovgt,"cmovgt",      IT_ICM, RES_PC, 0, PIPE_E0|PIPE_E1, 2, 2},

    {0x11,0x6c,I_implver,"implver",    IT_MSC, RES_PC, 0, PIPE_E0|PIPE_E1, 2, 2},  /* guessed */

    {0x11,0xff,I_end11,"end11",        IT_ERR, 0, 0, 0, 0, 0},

    /* Table12 */

    {0x12,0x00,I_beg12,"beg12",        IT_ERR, 0, 0, 0, 0},
    {0x12,0x02,I_mskbl,"mskbl",        IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0x06,I_extbl,"extbl",        IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0x0b,I_insbl,"insbl",        IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0x12,I_mskwl,"mskwl",        IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0x16,I_extwl,"extwl",        IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0x1b,I_inswl,"inswl",        IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0x22,I_mskll,"mskll",        IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0x26,I_extll,"extll",        IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0x2b,I_insll,"insll",        IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0x30,I_zap  ,"zap",          IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0x31,I_zapnot,"zapnot",      IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0x32,I_mskql,"mskql",        IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0x34,I_srl  ,"srl",          IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0x36,I_extql,"extql",        IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0x39,I_sll  ,"sll",          IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0x3b,I_insql,"insql",        IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0x3c,I_sra  ,"sra",          IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0x52,I_mskwh,"mskwh",        IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0x57,I_inswh,"inswh",        IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0x5a,I_extwh,"extwh",        IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0x62,I_msklh,"msklh",        IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0x67,I_inslh,"inslh",        IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0x6a,I_extlh,"extlh",        IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0x72,I_mskqh,"mskqh",        IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0x77,I_insqh,"insqh",        IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0x7a,I_extqh,"extqh",        IT_SFT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x12,0xff,I_end12,"end12",        IT_ERR, 0, 0, 0, 0, 0},

    /* Table13 */

    {0x13,0x00,I_beg13,"beg13",        IT_ERR, 0, 0, 0, 0, 0},
    {0x13,0x00,I_mull,"mull",          IT_MLL, RES_PC, 0, PIPE_E0, 8+2, 8+2},   /* we assume that worst case, ie. +2 cycles */
    {0x13,0x20,I_mulq,"mulq",          IT_MLQ, RES_PC, 0, PIPE_E0, 12+2, 12+2},  /* we assume that worst case, ie. +2 cycles */
    {0x13,0x30,I_umulh,"umulh",        IT_MLH, RES_PC, 0, PIPE_E0, 14+2, 14+2},  /* we assume that worst case, ie. +2 cycles */
    {0x13,0x40,I_mull_v,"mull/v",      IT_MLL, RES_PC|RES_TR, 0, PIPE_E0, 8+2, 8+2},
    {0x13,0x60,I_mulq_v,"mulq/v",      IT_MLQ, RES_PC|RES_TR, 0, PIPE_E0, 12+2, 12+2},
    {0x13,0xff,I_end13,"end13",        IT_ERR, 0, 0, 0, 0, 0},    

    /* Table14 */

    {0x14,0x000,I_beg14,"beg14",       IT_ERR, 0, 0, 0, 0, 0},
    {0x14,0x004,I_itofs,"itofs",       IT_I2F, RES_PC,0, PIPE_FA, 4, 4}, /* guessed */
    {0x14,0x00a,I_sqrtf_c,"sqrtf/c",   IT_ERR,  0, 0, 0, 0, 0},
    {0x14,0x00b,I_sqrts_c,"sqrts/c",   IT_ERR,  0, 0, 0, 0, 0},
    {0x14,0x014,I_itoff,"itoff",       IT_I2F, RES_PC,0, PIPE_FA, 4, 4}, /* guessed */
    {0x14,0x024,I_itoft,"itoft",       IT_I2F, RES_PC,0, PIPE_FA, 4, 4}, /* guessed */
    {0x14,0x02a,I_sqrtg_c,"sqrtg/c",   IT_ERR,  0,0, 0},
    {0x14,0x02b,I_sqrtt_c,"sqrtt/c",   IT_ERR,  0,0, 0},
    {0x14,0x04b,I_sqrts_m,"sqrts/m",   IT_ERR,  0,0, 0},
    {0x14,0x06b,I_sqrtt_m,"sqrtt/m",   IT_ERR,  0,0, 0},
    {0x14,0x08a,I_sqrtf,"sqrtf",       IT_ERR,  0,0, 0},
    {0x14,0x08b,I_sqrts,"sqrts",       IT_ERR,  0,0, 0},
    {0x14,0x0aa,I_sqrtg,"sqrtg",       IT_ERR,  0,0, 0},
    {0x14,0x0ab,I_sqrtt,"sqrtt",       IT_ERR,  0,0, 0},
    {0x14,0x0cb,I_sqrts_d,"sqrts/d",   IT_ERR,  0,0, 0},
    {0x14,0x0eb,I_sqrtt_d,"sqrtt/d",   IT_ERR,  0,0, 0},
    {0x14,0x10a,I_sqrtf_uc,"sqrtf/uc", IT_ERR,  0,0, 0},
    {0x14,0x10b,I_sqrts_uc,"sqrts/uc", IT_ERR,  0,0, 0},
    {0x14,0x12a,I_sqrtg_uc,"sqrtg/uc", IT_ERR,  0,0, 0},
    {0x14,0x12b,I_sqrtt_uc,"sqrtt/uc", IT_ERR,  0,0, 0},
    {0x14,0x14b,I_sqrts_um,"sqrts/um", IT_ERR,  0,0, 0},
    {0x14,0x16b,I_sqrtt_um,"sqrtt/um", IT_ERR,  0,0, 0},
    {0x14,0x18a,I_sqrtf_u,"sqrtf/u",   IT_ERR,  0,0, 0},
    {0x14,0x18b,I_sqrts_u,"sqrts/u",   IT_ERR,  0,0, 0},
    {0x14,0x1aa,I_sqrtg_u,"sqrtg/u",   IT_ERR,  0,0, 0},
    {0x14,0x1ab,I_sqrtt_u,"sqrtt/u",   IT_ERR,  0,0, 0},
    {0x14,0x1cb,I_sqrts_ud,"sqrts/ud", IT_ERR,  0,0, 0},
    {0x14,0x1eb,I_sqrtt_ud,"sqrtt/ud", IT_ERR,  0,0, 0},
    {0x14,0x40a,I_sqrtf_sc,"sqrtf/sc", IT_ERR,  0,0, 0},
    {0x14,0x42a,I_sqrtg_sc,"sqrtg/sc", IT_ERR,  0,0, 0},
    {0x14,0x48a,I_sqrtf_s,"sqrtf/s",   IT_ERR,  0,0, 0},
    {0x14,0x4aa,I_sqrtg_s,"sqrtg/s",   IT_ERR,  0,0, 0},
    {0x14,0x50a,I_sqrtf_suc,"sqrtf/suc", IT_ERR,  0,0, 0},
    {0x14,0x50b,I_sqrts_suc,"sqrts/suc", IT_ERR,  0,0, 0},
    {0x14,0x52a,I_sqrtg_suc,"sqrtg/suc", IT_ERR,  0,0, 0},
    {0x14,0x52b,I_sqrtt_suc,"sqrtt/suc", IT_ERR,  0,0, 0},
    {0x14,0x54b,I_sqrts_sum,"sqrts/sum", IT_ERR,  0,0, 0},
    {0x14,0x56b,I_sqrtt_sum,"sqrtt/sum", IT_ERR,  0,0, 0},
    {0x14,0x58a,I_sqrtf_su,"sqrtf/su",   IT_ERR,  0,0, 0},
    {0x14,0x58b,I_sqrts_su,"sqrts/su",   IT_ERR,  0,0, 0},
    {0x14,0x5aa,I_sqrtg_su,"sqrtg/su",   IT_ERR,  0,0, 0},
    {0x14,0x5ab,I_sqrtt_su,"sqrtt/su",   IT_ERR,  0,0, 0},
    {0x14,0x5cb,I_sqrts_sud,"sqrts/sud", IT_ERR,  0,0, 0},
    {0x14,0x5eb,I_sqrtt_sud,"sqrtt/sud", IT_ERR,  0,0, 0},
    {0x14,0x70b,I_sqrts_suic,"sqrts/suic", IT_ERR,  0, 0, 0},
    {0x14,0x72b,I_sqrtt_suic,"sqrtt/suic", IT_ERR,  0, 0, 0},
    {0x14,0x74b,I_sqrts_suim,"sqrts/suim", IT_ERR,  0, 0, 0},
    {0x14,0x76b,I_sqrtt_suim,"sqrtt/suim", IT_ERR,  0, 0, 0},
    {0x14,0x78b,I_sqrts_sui,"sqrts/sui",   IT_ERR,  0, 0, 0},
    {0x14,0x7ab,I_sqrtt_sui,"sqrtt/sui",   IT_ERR,  0, 0, 0},
    {0x14,0x7cb,I_sqrts_suid,"sqrts/suid", IT_ERR,  0, 0, 0},
    {0x14,0x7eb,I_sqrtt_suid,"sqrtt/suid", IT_ERR,  0, 0, 0},
    {0x14,0xfff,I_end14,"end14",           IT_ERR,  0, 0, 0, 0, 0},

    /* Table15 */

    {0x15,0x000,I_beg15,"beg15",         IT_ERR, 0, 0, 0, 0, 0},
    {0x15,0x000,I_addf_c,"addf/c",       IT_FA4, RES_PC,0, PIPE_FA, 4, 4},
    {0x15,0x001,I_subf_c,"subf/c",       IT_FS4, RES_PC,0, PIPE_FA, 4, 4},
    {0x15,0x002,I_mulf_c,"mulf/c",       IT_FM4, RES_PC,0, PIPE_FM, 4, 4},
    {0x15,0x003,I_divf_c,"divf/c",       IT_FD4, RES_PC,0, PIPE_FA, 23, 31}, /* we assume that worst case */
    {0x15,0x01e,I_cvtdg_c,"cvtdg/c",     IT_FCV, RES_PC,0, PIPE_FA, 4, 4},
    {0x15,0x020,I_addg_c,"addg/c",       IT_FA8, RES_PC,0, PIPE_FA, 4, 4},
    {0x15,0x021,I_subg_c,"subg/c",       IT_FS8, RES_PC,0, PIPE_FA, 4, 4},
    {0x15,0x022,I_mulg_c,"mulg/c",       IT_FM8, RES_PC,0, PIPE_FM, 4, 4},
    {0x15,0x023,I_divg_c,"divg/c",       IT_FD8, RES_PC,0, PIPE_FA, 42, 60}, /* we assume that worst case */
    {0x15,0x02c,I_cvtgf_c,"cvtgf/c",     IT_FCV, RES_PC,0, PIPE_FA, 4, 4},
    {0x15,0x02d,I_cvtgd_c,"cvtgd/c",     IT_FCV, RES_PC,0, PIPE_FA, 4, 4},
    {0x15,0x02f,I_cvtgq_c,"cvtgq/c",     IT_FCV, RES_PC,0, PIPE_FA, 4, 4},
    {0x15,0x03c,I_cvtqf_c,"cvtqf/c",     IT_FCV, RES_PC,0, PIPE_FA, 4, 4},
    {0x15,0x03e,I_cvtqg_c,"cvtqg/c",     IT_FCV, RES_PC,0, PIPE_FA, 4, 4},
    {0x15,0x080,I_addf,"addf",           IT_FA4, RES_PC,0, PIPE_FA, 4, 4},
    {0x15,0x081,I_subf,"subf",           IT_FS4, RES_PC,0, PIPE_FA, 4, 4},
    {0x15,0x082,I_mulf,"mulf",           IT_FM4, RES_PC,0, PIPE_FM, 4, 4},
    {0x15,0x083,I_divf,"divf",           IT_FD4, RES_PC,0, PIPE_FA, 23, 31}, /* we assume that worst case */
    {0x15,0x09e,I_cvtdg,"cvtdg",         IT_FCV, RES_PC,0, PIPE_FA, 4, 4},
    {0x15,0x0a0,I_addg,"addg",           IT_FA8, RES_PC,0, PIPE_FA, 4, 4},
    {0x15,0x0a1,I_subg,"subg",           IT_FS8, RES_PC,0, PIPE_FA, 4, 4},
    {0x15,0x0a2,I_mulg,"mulg",           IT_FM8, RES_PC,0, PIPE_FM, 4, 4},
    {0x15,0x0a3,I_divg,"divg",           IT_FD8, RES_PC,0, PIPE_FA, 42, 60}, /* we assume that worst case */
    {0x15,0x0a5,I_cmpgeq,"cmpgeq",       IT_FCP, RES_PC,0, PIPE_FA, 4, 4},
    {0x15,0x0a6,I_cmpglt,"cmpglt",       IT_FCP, RES_PC,0, PIPE_FA, 4, 4},
    {0x15,0x0a7,I_cmpgle,"cmpgle",       IT_FCP, RES_PC,0, PIPE_FA, 4, 4},
    {0x15,0x0ac,I_cvtgf,"cvtgf",         IT_FCV, RES_PC,0, PIPE_FA, 4, 4},
    {0x15,0x0ad,I_cvtgd,"cvtgd",         IT_FCV, RES_PC,0, PIPE_FA, 4, 4},
    {0x15,0x0af,I_cvtgq,"cvtgq",         IT_FCV, RES_PC,0, PIPE_FA, 4, 4},
    {0x15,0x0bc,I_cvtqf,"cvtqf",         IT_FCV, RES_PC,0, PIPE_FA, 4, 4},
    {0x15,0x0be,I_cvtqg,"cvtqg",         IT_FCV, RES_PC,0, PIPE_FA, 4, 4},
    {0x15,0x100,I_addf_uc,"addf/uc",     IT_FA4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x101,I_subf_uc,"subf/uc",     IT_FS4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x102,I_mulf_uc,"mulf/uc",     IT_FM4, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x15,0x103,I_divf_uc,"divf/uc",     IT_FD4, RES_PC|RES_FP,0, PIPE_FA, 23, 31}, /* we assume that worst case */
    {0x15,0x11e,I_cvtdg_uc,"cvtdg/uc",   IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x120,I_addg_uc,"addg/uc",     IT_FA8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x121,I_subg_uc,"subg/uc",     IT_FS8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x122,I_mulg_uc,"mulg/uc",     IT_FM8, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x15,0x123,I_divg_uc,"divg/uc",     IT_FD8, RES_PC|RES_FP,0, PIPE_FA, 42, 60}, /* we assume that worst case */
    {0x15,0x12c,I_cvtgf_uc,"cvtgf/uc",   IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x12d,I_cvtgd_uc,"cvtgd/uc",   IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x12f,I_cvtgq_vc,"cvtgq/vc",   IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x180,I_addf_u,"addf/u",       IT_FA4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x181,I_subf_u,"subf/u",       IT_FS4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x182,I_mulf_u,"mulf/u",       IT_FM4, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x15,0x183,I_divf_u,"divf/u",       IT_FD4, RES_PC|RES_FP,0, PIPE_FA, 23, 31}, /* we assume that worst case */
    {0x15,0x19e,I_cvtdg_u,"cvtdg/u",     IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x1a0,I_addg_u,"addg/u",       IT_FA8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x1a1,I_subg_u,"subg/u",       IT_FS8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x1a2,I_mulg_u,"mulg/u",       IT_FM8, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x15,0x1a3,I_divg_u,"divg/u",       IT_FD8, RES_PC|RES_FP,0, PIPE_FA, 42, 60}, /* we assume that worst case */
    {0x15,0x1ac,I_cvtgf_u,"cvtgf/u",     IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x1ad,I_cvtgd_u,"cvtgd/u",     IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x1af,I_cvtgq_v,"cvtgq/v",     IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x400,I_addf_sc,"addf/sc",     IT_FA4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x401,I_subf_sc,"subf/sc",     IT_FS4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x402,I_mulf_sc,"mulf/sc",     IT_FM4, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x15,0x403,I_divf_sc,"divf/sc",     IT_FD4, RES_PC|RES_FP,0, PIPE_FA, 23, 31},
    {0x15,0x41e,I_cvtdg_sc,"cvtdg/sc",   IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x420,I_addg_sc,"addg/sc",     IT_FA8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x421,I_subg_sc,"subg/sc",     IT_FS8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x422,I_mulg_sc,"mulg/sc",     IT_FM8, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x15,0x423,I_divg_sc,"divg/sc",     IT_FD8, RES_PC|RES_FP,0, PIPE_FA, 42, 60},
    {0x15,0x42c,I_cvtgf_sc,"cvtgf/sc",   IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x42d,I_cvtgd_sc,"cvtgd/sc",   IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x42f,I_cvtgq_sc,"cvtgq/sc",   IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x480,I_addf_s,"addf/s",       IT_FA4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x481,I_subf_s,"subf/s",       IT_FS4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x482,I_mulf_s,"mulf/s",       IT_FM4, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x15,0x483,I_divf_s,"divf/s",       IT_FD4, RES_PC|RES_FP,0, PIPE_FA, 23, 31},
    {0x15,0x49e,I_cvtdg_s,"cvtdg/s",     IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x4a0,I_addg_s,"addg/s",       IT_FA8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x4a1,I_subg_s,"subg/s",       IT_FS8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x4a2,I_mulg_s,"mulg/s",       IT_FM8, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x15,0x4a3,I_divg_s,"divg/s",       IT_FD8, RES_PC|RES_FP,0, PIPE_FA, 42, 60},
    {0x15,0x4a5,I_cmpgeq_s,"cmpgeq/s",   IT_FCP, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x4a6,I_cmpglt_s,"cmpglt/s",   IT_FCP, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x4a7,I_cmpgle_s,"cmpgle/s",   IT_FCP, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x4ac,I_cvtgf_s,"cvtgf/s",     IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x4ad,I_cvtgd_s,"cvtgd/s",     IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x4af,I_cvtgq_s,"cvtgq/s",     IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x500,I_addf_suc,"addf/suc",   IT_FA4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x501,I_subf_suc,"subf/suc",   IT_FS4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x502,I_mulf_suc,"mulf/suc",   IT_FM4, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x15,0x503,I_divf_suc,"divf/suc",   IT_FD4, RES_PC|RES_FP,0, PIPE_FA, 23, 31},
    {0x15,0x51e,I_cvtdg_suc,"cvtdg/suc", IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x520,I_addg_suc,"addg/suc",   IT_FA8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x521,I_subg_suc,"subg/suc",   IT_FS8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x522,I_mulg_suc,"mulg/suc",   IT_FM8, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x15,0x523,I_divg_suc,"divg/suc",   IT_FD8, RES_PC|RES_FP,0, PIPE_FA, 42, 60},
    {0x15,0x52c,I_cvtgf_suc,"cvtgf/suc", IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x52d,I_cvtgd_suc,"cvtgd/suc", IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x52f,I_cvtgq_svc,"cvtgq/svc", IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x580,I_addf_su,"addf/su",     IT_FA4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x581,I_subf_su,"subf/su",     IT_FS4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x582,I_mulf_su,"mulf/su",     IT_FM4, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x15,0x583,I_divf_su,"divf/su",     IT_FD4, RES_PC|RES_FP,0, PIPE_FA, 23, 31},
    {0x15,0x59e,I_cvtdg_su,"cvtdg/su",   IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x5a0,I_addg_su,"addg/su",     IT_FA8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x5a1,I_subg_su,"subg/su",     IT_FS8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x5a2,I_mulg_su,"mulg/su",     IT_FM8, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x15,0x5a3,I_divg_su,"divg/su",     IT_FD8, RES_PC|RES_FP,0, PIPE_FA, 42, 60},
    {0x15,0x5ac,I_cvtgf_su,"cvtgf/su",   IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x5ad,I_cvtgd_su,"cvtgd/su",   IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0x5af,I_cvtgq_sv,"cvtgq/sv",   IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x15,0xfff,I_end15,"end15",         IT_ERR, 0, 0, 0, 0},

    /* Table16 */ 

    {0x16,0x000,I_beg16,"beg16",           IT_ERR, 0, 0, 0, 0, 0},
    {0x16,0x000,I_adds_c,"adds/c",         IT_FA4,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x001,I_subs_c,"subs/c",         IT_FS4,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x002,I_muls_c,"muls/c",         IT_FM4,RES_PC,0, PIPE_FM, 4, 4},
    {0x16,0x003,I_divs_c,"divs/c",         IT_FD4,RES_PC,0, PIPE_FA, 23, 31}, 
    {0x16,0x020,I_addt_c,"addt/c",         IT_FA8,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x021,I_subt_c,"subt/c",         IT_FS8,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x022,I_mult_c,"mult/c",         IT_FM8,RES_PC,0, PIPE_FM, 4, 4},
    {0x16,0x023,I_divt_c,"divt/c",         IT_FD8,RES_PC,0, PIPE_FA, 42, 60}, /* we assume that worst case */
    {0x16,0x02c,I_cvtts_c,"cvtts/c",       IT_FCV,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x02f,I_cvttq_c,"cvttq/c",       IT_FCV,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x03c,I_cvtqs_c,"cvtqs/c",       IT_FCV,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x03e,I_cvtqt_c,"cvtqt/c",       IT_FCV,RES_PC,0, PIPE_FA, 4, 4},

    {0x16,0x040,I_adds_m,"adds/m",         IT_FA4,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x041,I_subs_m,"subs/m",         IT_FS4,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x042,I_muls_m,"muls/m",         IT_FM4,RES_PC,0, PIPE_FM, 4, 4},
    {0x16,0x043,I_divs_m,"divs/m",         IT_FD4,RES_PC,0, PIPE_FA, 23, 31},
    {0x16,0x060,I_addt_m,"addt/m",         IT_FA8,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x061,I_subt_m,"subt/m",         IT_FS8,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x062,I_mult_m,"mult/m",         IT_FM8,RES_PC,0, PIPE_FM, 4, 4},
    {0x16,0x063,I_divt_m,"divt/m",         IT_FD8,RES_PC,0, PIPE_FA, 42, 60}, /* we assume that worst case */
    {0x16,0x06c,I_cvtts_m,"cvtts/m",       IT_FCV,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x06f,I_cvttq_m,"cvttq/m",       IT_FCV,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x07c,I_cvtqs_m,"cvtqs/m",       IT_FCV,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x07e,I_cvtqt_m,"cvtqt/m",       IT_FCV,RES_PC,0, PIPE_FA, 4, 4},

    {0x16,0x080,I_adds,"adds",             IT_FA4,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x081,I_subs,"subs",             IT_FS4,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x082,I_muls,"muls",             IT_FM4,RES_PC,0, PIPE_FM, 4, 4},
    {0x16,0x083,I_divs,"divs",             IT_FD4,RES_PC,0, PIPE_FA, 23, 31},
    {0x16,0x0a0,I_addt,"addt",             IT_FA8,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x0a1,I_subt,"subt",             IT_FS8,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x0a2,I_mult,"mult",             IT_FM8,RES_PC,0, PIPE_FM, 4, 4},
    {0x16,0x0a3,I_divt,"divt",             IT_FD8,RES_PC,0, PIPE_FA, 42, 60}, /* we assume that worst case */
    {0x16,0x0a4,I_cmptun,"cmptun",         IT_FCP,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x0a5,I_cmpteq,"cmpteq",         IT_FCP,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x0a6,I_cmptlt,"cmptlt",         IT_FCP,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x0a7,I_cmptle,"cmptle",         IT_FCP,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x0ac,I_cvtts,"cvtts",           IT_FCV,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x0af,I_cvttq,"cvttq",           IT_FCV,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x0bc,I_cvtqs,"cvtqs",           IT_FCV,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x0be,I_cvtqt,"cvtqt",           IT_FCV,RES_PC,0, PIPE_FA, 4, 4},

    {0x16,0x0c0,I_adds_d,"adds/d",         IT_FA4,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x0c1,I_subs_d,"subs/d",         IT_FS4,RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x0c2,I_muls_d,"muls/d",         IT_FM4,RES_PC,0, PIPE_FM, 4, 4},
    {0x16,0x0c3,I_divs_d,"divs/d",         IT_FD4, RES_PC,0, PIPE_FA, 23, 31},
    {0x16,0x0e0,I_addt_d,"addt/d",         IT_FA8, RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x0e1,I_subt_d,"subt/d",         IT_FS8, RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x0e2,I_mult_d,"mult/d",         IT_FM8, RES_PC,0, PIPE_FM, 4, 4},
    {0x16,0x0e3,I_divt_d,"divt/d",         IT_FD8, RES_PC,0, PIPE_FA, 42, 60}, /* we assume that worst case */
    {0x16,0x0ec,I_cvtts_d,"cvtts/d",       IT_FCV, RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x0ef,I_cvttq_d,"cvttq/d",       IT_FCV, RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x0fc,I_cvtqs_d,"cvtqs/d",       IT_FCV, RES_PC,0, PIPE_FA, 4, 4},
    {0x16,0x0fe,I_cvtqt_d,"cvtqt/d",       IT_FCV, RES_PC,0, PIPE_FA, 4, 4},

    {0x16,0x100,I_adds_uc,"adds/uc",       IT_FA4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x101,I_subs_uc,"subs/uc",       IT_FS4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x102,I_muls_uc,"muls/uc",       IT_FM4, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x16,0x103,I_divs_uc,"divs/uc",       IT_FD4, RES_PC|RES_FP,0, PIPE_FA, 23, 31},
    {0x16,0x120,I_addt_uc,"addt/uc",       IT_FA8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x121,I_subt_uc,"subt/uc",       IT_FS8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x122,I_mult_uc,"mult/uc",       IT_FM8, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x16,0x123,I_divt_uc,"divt/uc",       IT_FD8, RES_PC|RES_FP,0, PIPE_FA, 42, 60}, /* we assume that worst case */
    {0x16,0x12c,I_cvtts_uc,"cvtts/uc",     IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x12f,I_cvttq_vc,"cvttq/vc",     IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},

    {0x16,0x140,I_adds_um,"adds/um",       IT_FA4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x141,I_subs_um,"subs/um",       IT_FS4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x142,I_muls_um,"muls/um",       IT_FM4, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x16,0x143,I_divs_um,"divs/um",       IT_FD4, RES_PC|RES_FP,0, PIPE_FA, 23, 31},
    {0x16,0x160,I_addt_um,"addt/um",       IT_FA8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x161,I_subt_um,"subt/um",       IT_FS8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x162,I_mult_um,"mult/um",       IT_FM8, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x16,0x163,I_divt_um,"divt/um",       IT_FD8, RES_PC|RES_FP,0, PIPE_FA, 42, 60}, /* we assume that worst case */
    {0x16,0x16c,I_cvtts_um,"cvtts/um",     IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x16f,I_cvttq_vm,"cvttq/vm",     IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},

    {0x16,0x180,I_adds_u,"adds/u",         IT_FA4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x181,I_subs_u,"subs/u",         IT_FS4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x182,I_muls_u,"muls/u",         IT_FM4, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x16,0x183,I_divs_u,"divs/u",         IT_FD4, RES_PC|RES_FP,0, PIPE_FA, 23, 31},
    {0x16,0x1a0,I_addt_u,"addt/u",         IT_FA8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x1a1,I_subt_u,"subt/u",         IT_FS8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x1a2,I_mult_u,"mult/u",         IT_FM8, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x16,0x1a3,I_divt_u,"divt/u",         IT_FD8, RES_PC|RES_FP,0, PIPE_FA, 42, 60}, /* we assume that worst case */
    {0x16,0x1ac,I_cvtts_u,"cvtts/u",       IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x1af,I_cvttq_v,"cvttq/v",       IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},

    {0x16,0x1c0,I_adds_ud,"adds/ud",       IT_FA4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x1c1,I_subs_ud,"subs/ud",       IT_FS4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x1c2,I_muls_ud,"muls/ud",       IT_FM4, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x16,0x1c3,I_divs_ud,"divs/ud",       IT_FD4, RES_PC|RES_FP,0, PIPE_FA, 23, 31},
    {0x16,0x1e0,I_addt_ud,"addt/ud",       IT_FA8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x1e1,I_subt_ud,"subt/ud",       IT_FS8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x1e2,I_mult_ud,"mult/ud",       IT_FM8, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x16,0x1e3,I_divt_ud,"divt/ud",       IT_FD8, RES_PC|RES_FP,0, PIPE_FA, 42, 60}, /* we assume that worst case */
    {0x16,0x1ec,I_cvtts_ud,"cvtts/ud",     IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x1ef,I_cvttq_vd,"cvttq/vd",     IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x2ac,I_cvtst,"cvtst",           IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},

    {0x16,0x500,I_adds_suc,"adds/suc",     IT_FA4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x501,I_subs_suc,"subs/suc",     IT_FS4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x502,I_muls_suc,"muls/suc",     IT_FM4, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x16,0x503,I_divs_suc,"divs/suc",     IT_FD4, RES_PC|RES_FP,0, PIPE_FA, 23, 31},
    {0x16,0x520,I_addt_suc,"addt/suc",     IT_FA8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x521,I_subt_suc,"subt/suc",     IT_FS8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x522,I_mult_suc,"mult/suc",     IT_FM8, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x16,0x523,I_divt_suc,"divt/suc",     IT_FD8, RES_PC|RES_FP,0, PIPE_FA, 42, 60}, /* we assume that worst case */
    {0x16,0x52c,I_cvtts_suc,"cvtts/suc",   IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x52f,I_cvttq_svc,"cvttq/svc",   IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},

    {0x16,0x540,I_adds_sum,"adds/sum",     IT_FA4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x541,I_subs_sum,"subs/sum",     IT_FS4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x542,I_muls_sum,"muls/sum",     IT_FM4, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x16,0x543,I_divs_sum,"divs/sum",     IT_FD4, RES_PC|RES_FP,0, PIPE_FA, 23, 31},
    {0x16,0x560,I_addt_sum,"addt/sum",     IT_FA8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x561,I_subt_sum,"subt/sum",     IT_FS8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x562,I_mult_sum,"mult/sum",     IT_FM8, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x16,0x563,I_divt_sum,"divt/sum",     IT_FD8, RES_PC|RES_FP,0, PIPE_FA, 42, 60}, /* we assume that worst case */
    {0x16,0x56c,I_cvtts_sum,"cvtts/sum",   IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x56f,I_cvttq_svm,"cvttq/svm",   IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},

    {0x16,0x580,I_adds_su,"adds/su",       IT_FA4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x581,I_subs_su,"subs/su",       IT_FS4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x582,I_muls_su,"muls/su",       IT_FM4, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x16,0x583,I_divs_su,"divs/su",       IT_FD4, RES_PC|RES_FP,0, PIPE_FA, 23, 31},
    {0x16,0x5a0,I_addt_su,"addt/su",       IT_FA8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x5a1,I_subt_su,"subt/su",       IT_FS8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x5a2,I_mult_su,"mult/su",       IT_FM8, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x16,0x5a3,I_divt_su,"divt/su",       IT_FD8, RES_PC|RES_FP,0, PIPE_FA, 42, 60}, /* we assume that worst case */
    {0x16,0x5a4,I_cmptun_su,"cmptun/su",   IT_FCP, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x5a5,I_cmpteq_su,"cmpteq/su",   IT_FCP, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x5a6,I_cmptlt_su,"cmptlt/su",   IT_FCP, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x5a7,I_cmptle_su,"cmptle/su",   IT_FCP, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x5ac,I_cvtts_su,"cvtts/su",     IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x5af,I_cvttq_sv,"cvttq/sv",     IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},

    {0x16,0x5c0,I_adds_sud,"adds/sud",     IT_FA4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x5c1,I_subs_sud,"subs/sud",     IT_FS4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x5c2,I_muls_sud,"muls/sud",     IT_FM4, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x16,0x5c3,I_divs_sud,"divs/sud",     IT_FD4, RES_PC|RES_FP,0, PIPE_FA, 23, 31},
    {0x16,0x5e0,I_addt_sud,"addt/sud",     IT_FA8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x5e1,I_subt_sud,"subt/sud",     IT_FS8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x5e2,I_mult_sud,"mult/sud",     IT_FM8, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x16,0x5e3,I_divt_sud,"divt/sud",     IT_FD8, RES_PC|RES_FP,0, PIPE_FA, 42, 60}, /* we assume that worst case */
    {0x16,0x5ec,I_cvtts_sud,"cvtts/sud",   IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x5ef,I_cvttq_svd,"cvttq/svd",   IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x6ac,I_cvtst_s,"cvtst/s",       IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},

    {0x16,0x700,I_adds_suic,"adds/suic",   IT_FA4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x701,I_subs_suic,"subs/suic",   IT_FS4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x702,I_muls_suic,"muls/suic",   IT_FM4, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x16,0x703,I_divs_suic,"divs/suic",   IT_FD4, RES_PC|RES_FP,0, PIPE_FA, 23, 31},
    {0x16,0x720,I_addt_suic,"addt/suic",   IT_FA8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x721,I_subt_suic,"subt/suic",   IT_FS8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x722,I_mult_suic,"mult/suic",   IT_FM8, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x16,0x723,I_divt_suic,"divt/suic",   IT_FD8, RES_PC|RES_FP,0, PIPE_FA, 42, 60}, /* we assume that worst case */
    {0x16,0x72c,I_cvtts_suic,"cvtts/suic", IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x72f,I_cvttq_svic,"cvttq/svic", IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x73c,I_cvtqs_suic,"cvtqs/suic", IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x73e,I_cvtqt_suic,"cvtqt/suic", IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},

    {0x16,0x740,I_adds_suim,"adds/suim",   IT_FA4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x741,I_subs_suim,"subs/suim",   IT_FS4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x742,I_muls_suim,"muls/suim",   IT_FM4, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x16,0x743,I_divs_suim,"divs/suim",   IT_FD4, RES_PC|RES_FP,0, PIPE_FA, 23, 31},
    {0x16,0x760,I_addt_suim,"addt/suim",   IT_FA8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x761,I_subt_suim,"subt/suim",   IT_FS8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x762,I_mult_suim,"mult/suim",   IT_FM8, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x16,0x763,I_divt_suim,"divt/suim",   IT_FD8, RES_PC|RES_FP,0, PIPE_FA, 42, 60}, /* we assume that worst case */
    {0x16,0x76c,I_cvtts_suim,"cvtts/suim", IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x76f,I_cvttq_svim,"cvttq/svim", IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x77c,I_cvtqs_suim,"cvtqs/suim", IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x77e,I_cvtqt_suim,"cvtqt/suim", IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},

    {0x16,0x780,I_adds_sui,"adds/sui",     IT_FA4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x781,I_subs_sui,"subs/sui",     IT_FS4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x782,I_muls_sui,"muls/sui",     IT_FM4, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x16,0x783,I_divs_sui,"divs/sui",     IT_FD4, RES_PC|RES_FP,0, PIPE_FA, 23, 31},
    {0x16,0x7a0,I_addt_sui,"addt/sui",     IT_FA8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x7a1,I_subt_sui,"subt/sui",     IT_FS8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x7a2,I_mult_sui,"mult/sui",     IT_FM8, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x16,0x7a3,I_divt_sui,"divt/sui",     IT_FD8, RES_PC|RES_FP,0, PIPE_FA, 42, 60}, /* we assume that worst case */
    {0x16,0x7ac,I_cvtts_sui,"cvtts/sui",   IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x7af,I_cvttq_svi,"cvttq/svi",   IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x7bc,I_cvtqs_sui,"cvtqs/sui",   IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x7be,I_cvtqt_sui,"cvtqt/sui",   IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},

    {0x16,0x7c0,I_adds_suid,"adds/suid",   IT_FA4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x7c1,I_subs_suid,"subs/suid",   IT_FS4, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x7c2,I_muls_suid,"muls/suid",   IT_FM4, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x16,0x7c3,I_divs_suid,"divs/suid",   IT_FD4, RES_PC|RES_FP,0, PIPE_FA, 23, 31},
    {0x16,0x7e0,I_addt_suid,"addt/suid",   IT_FA8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x7e1,I_subt_suid,"subt/suid",   IT_FS8, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x7e2,I_mult_suid,"mult/suid",   IT_FM8, RES_PC|RES_FP,0, PIPE_FM, 4, 4},
    {0x16,0x7e3,I_divt_suid,"divt/suid",   IT_FD8, RES_PC|RES_FP,0, PIPE_FA, 42, 60}, /* we assume that worst case */
    {0x16,0x7ec,I_cvtts_suid,"cvtts/suid", IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x7ef,I_cvttq_svid,"cvttq/svid", IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x7fc,I_cvtqs_suid,"cvtqs/suid", IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0x7fe,I_cvtqt_suid,"cvtqt/suid", IT_FCV, RES_PC|RES_FP,0, PIPE_FA, 4, 4},
    {0x16,0xfff,I_end16,"end16",           IT_ERR, 0, 0, 0, 0, 0},

    /* Table17 */
    
    {0x17,0x000,I_beg17,"beg17",       IT_ERR, 0, 0, 0, 0, 0},
    {0x17,0x010,I_cvtlq,"cvtlq",       IT_FCV, RES_PC, 0, PIPE_FA },
    {0x17,0x020,I_cpys,"cpys",         IT_FCS, RES_PC, 0, PIPE_FA|PIPE_FM, 4, 4},
    {0x17,0x021,I_cpysn,"cpysn",       IT_FCN, RES_PC, 0, PIPE_FA, 4, 4},
    {0x17,0x022,I_cpyse,"cpyse",       IT_FCE, RES_PC, 0, PIPE_FA, 4, 4},
    {0x17,0x024,I_mt_fpcr,"mt_fpcr",   IT_R2F, RES_PC|RES_FP, 0, PIPE_FA, 4, 4},   /* guessed */
    {0x17,0x025,I_mf_fpcr,"mf_fpcr",   IT_F2R, RES_PC, RES_FP, PIPE_FA, 4, 4},     /* guessed */
    {0x17,0x02a,I_fcmoveq,"fcmoveq",   IT_FCM, RES_PC, 0, PIPE_FA, 4, 4},
    {0x17,0x02b,I_fcmovne,"fcmovne",   IT_FCM, RES_PC, 0, PIPE_FA, 4, 4},
    {0x17,0x02c,I_fcmovlt,"fcmovlt",   IT_FCM, RES_PC, 0, PIPE_FA, 4, 4},
    {0x17,0x02d,I_fcmovge,"fcmovge",   IT_FCM, RES_PC, 0, PIPE_FA, 4, 4},
    {0x17,0x02e,I_fcmovle,"fcmovle",   IT_FCM, RES_PC, 0, PIPE_FA, 4, 4},
    {0x17,0x02f,I_fcmovgt,"fcmovgt",   IT_FCM, RES_PC, 0, PIPE_FA, 4, 4},
    {0x17,0x030,I_cvtql,"cvtql",       IT_FCV, RES_PC, 0, PIPE_FA, 4, 4},
    {0x17,0x130,I_cvtql_v,"cvtql/v",   IT_FCV, RES_PC|RES_FP, 0, PIPE_FA, 4, 4},
    {0x17,0x530,I_cvtql_sv,"cvtql/sv", IT_FCV, RES_PC|RES_FP, 0, PIPE_FA, 4, 4},
    {0x17,0xfff,I_end17,"end17",       IT_ERR, 0, 0, 0, 0, 0},

    
    /* Table18 */

    {0x18,0x0000,I_beg18,"beg18",     IT_ERR, 0, 0, 0, 0, 0},
    {0x18,0x0000,I_trapb,"trapb",     IT_MSC, RES_PC,RES_TR, PIPE_E0, 0, 0},
    {0x18,0x0400,I_excb,"excb",       IT_MSC, RES_PC, RES_FP|RES_TR, PIPE_E0, 0, 0}, /* guessed */
    {0x18,0x4000,I_mb,"mb",           IT_MEM, RES_PC, RES_LD|RES_ST, PIPE_E0, 0, 0},
    {0x18,0x4400,I_wmb,"wmb",         IT_MEM, RES_PC, RES_ST, PIPE_E0, 0, 0},
    {0x18,0x8000,I_fetch,"fetch",     IT_MEM, RES_PC, 0, PIPE_E0, 0, 0},
    {0x18,0xa000,I_fetch_m,"fetch_m", IT_MEM, RES_PC, 0, PIPE_E0, 0, 0},
    {0x18,0xc000,I_rpcc,"rpcc",       IT_MSC, RES_PC, 0, PIPE_E0, 2, 2},
    {0x18,0xe000,I_rc,"rc",           IT_ERR, 0, 0, 0, 1, 1},     /* guessed */
    {0x18,0xe800,I_ecb,"ecb",         IT_ERR, 0, 0, 0, 0, 0},     /* guessed */
    {0x18,0xf000,I_rs,"rs",           IT_ERR, 0, 0, 0, 1, 1},     /* guessed */
    {0x18,0xf800,I_wh64,"wh64",       IT_ERR, 0, 0, 0, 0, 0},     /* guessed */
    {0x18,0xffff,I_end18,"end18",     IT_ERR, 0, 0, 0, 0, 0},

    /* Table1B */
    
    {0x1a,0x0,I_beg1a,"beg1a",        IT_ERR, 0, 0, 0, 0, 0},
    {0x1a,0x0,I_jmp,"jmp",            IT_JMP, 0, RES_PC, PIPE_E1, 1, 1},
    {0x1a,0x1,I_jsr,"jsr",            IT_JMP, 0, RES_PC, PIPE_E1, 1, 1},
    {0x1a,0x2,I_ret,"ret",            IT_JMP, 0, RES_PC, PIPE_E1, 1, 1},
    {0x1a,0x3,I_jsr_co,"jsr_co",      IT_JMP, 0, RES_PC, PIPE_E1, 1, 1},
    {0x1a,0xf,I_end1a,"end1a",        IT_ERR, 0, 0, 0, 0, 0},        

    /* Table1C */

    {0x1c,0x00,I_beg1c,"beg1c",       IT_ERR, 0, 0, 0, 0, 0},
    {0x1c,0x00,I_sextb,"sextb",       IT_EXT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x1c,0x01,I_sextw,"sextw",       IT_EXT, RES_PC, 0, PIPE_E0, 1, 1},
    {0x1c,0x30,I_ctpop,"ctpop",       IT_IOP, RES_PC, 0, PIPE_E0, 2, 2}, /* guessed */
    {0x1c,0x31,I_perr,"perr",         IT_IOP, RES_PC, 0, PIPE_E0, 2, 2},
    {0x1c,0x32,I_ctlz,"ctlz",         IT_IOP, RES_PC, 0, PIPE_E0, 2, 2}, /* guessed */
    {0x1c,0x33,I_cttz,"cttz",         IT_IOP, RES_PC, 0, PIPE_E0, 2, 2}, /* guessed */
    {0x1c,0x34,I_unpkbw,"unpkbw",     IT_IOP, RES_PC, 0, PIPE_E0, 2, 2},
    {0x1c,0x35,I_unpkbl,"unpkbl",     IT_IOP, RES_PC, 0, PIPE_E0, 2, 2},
    {0x1c,0x36,I_pkwb,"pkwb",         IT_IOP, RES_PC, 0, PIPE_E0, 2, 2},
    {0x1c,0x37,I_pklb,"pklb",         IT_IOP, RES_PC, 0, PIPE_E0, 2, 2},
    {0x1c,0x38,I_minsb8,"minsb8",     IT_IOP, RES_PC, 0, PIPE_E0, 2, 2},
    {0x1c,0x39,I_minsw4,"minsw4",     IT_IOP, RES_PC, 0, PIPE_E0, 2, 2},
    {0x1c,0x3a,I_minub8,"minub8",     IT_IOP, RES_PC, 0, PIPE_E0, 2, 2},
    {0x1c,0x3b,I_minuw4,"minuw4",     IT_IOP, RES_PC, 0, PIPE_E0, 2, 2},
    {0x1c,0x3c,I_maxub8,"maxub8",     IT_IOP, RES_PC, 0, PIPE_E0, 2, 2},
    {0x1c,0x3d,I_maxuw4,"maxuw4",     IT_IOP, RES_PC, 0, PIPE_E0, 2, 2},
    {0x1c,0x3e,I_maxsb8,"maxsb8",     IT_IOP, RES_PC, 0, PIPE_E0, 2, 2},
    {0x1c,0x3f,I_maxsw4,"maxsw4",     IT_IOP, RES_PC, 0, PIPE_E0, 2, 2},
    {0x1c,0x70,I_ftoit,"ftoit",       IT_F2I, RES_PC, 0, 0},
    {0x1c,0x78,I_ftois,"ftois",       IT_F2I, RES_PC, 0, 0},
    {0x1c,0xff,I_end1c,"end1c",       IT_ERR, 0, 0, 0, 0},

    /* special opcodes */

    {0x0b,0x0b,I_unop,"unop",         IT_ULD, 0, 0, 0, 0, 0}    
};














